package graph;

import java.util.ArrayList;

public class GraphDemo {

    public static void main(String[] args) {
        final Graph graph = makeGraph();
        System.out.println(graph);
        System.out.println();
        final Node nodeA = graph.getNodes().get(0);
        System.out.println("breadth first: " + nodeList(graph.breadthFirst(nodeA)));
        System.out.println("depth first: " + nodeList(graph.depthFirst(nodeA)));
    }

    private static Graph makeGraph() {
        final Node nodeA = new Node("A");
        final Node nodeB = new Node("B");
        final Node nodeC = new Node("C");
        final Node nodeD = new Node("D");
        final Node nodeE = new Node("E");
        final Graph graph = new Graph();
        graph.addNode(nodeA);
        graph.addNode(nodeB);
        graph.addNode(nodeC);
        graph.addNode(nodeD);
        graph.addNode(nodeE);
        nodeA.addEdge(new Edge(2, nodeB));
        nodeA.addEdge(new Edge(4, nodeD));
        nodeB.addEdge(new Edge(2, nodeA));
        nodeB.addEdge(new Edge(2, nodeC));
        nodeB.addEdge(new Edge(4, nodeE));
        nodeC.addEdge(new Edge(2, nodeB));
        nodeD.addEdge(new Edge(4, nodeA));
        nodeD.addEdge(new Edge(2, nodeE));
        nodeE.addEdge(new Edge(4, nodeB));
        nodeE.addEdge(new Edge(2, nodeD));
        return graph;
    }

    private static String nodeList(ArrayList<Node> nodes) {
        final ArrayList<String> names = new ArrayList<>();
        for (Node n : nodes)
            names.add(n.getName());
        return names.toString();
    }
}
