package tournament;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class OrdinaryGame extends Game{

    private Game Player1;
    private Game Player2;

    public OrdinaryGame(Game Player1, Game Player2) {
        this.Player1 = Player1;
        this.Player2 = Player2;
    }

    @Override
    public String getPlayer1() {
        return Player1.getWinner();
    }

    @Override
    public String getPlayer2() {
        return Player2.getWinner();
    }

    @Override
    public List<String> getAllPlayers() {
        List<String> temp = new ArrayList<>();
        temp.addAll(Player1.getAllPlayers());
        temp.addAll(Player2.getAllPlayers());
        return temp;
    }

    @Override
    public List<String> getRemaningPlayers() {
        if(this.getWinner() != null)
            return new ArrayList<>(Arrays.asList(this.getWinner()));
        List<String> temp = new ArrayList<>();
        temp.addAll(Player1.getRemaningPlayers());
        temp.addAll(Player2.getRemaningPlayers());
        return temp;
    }

    @Override
    public List<Game> getAllGames() {
        List<Game> temp = new ArrayList<>();
        temp.addAll(Player1.getAllGames());
        temp.addAll(Player2.getAllGames());
        return temp;
    }
}