package tournament;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class SeededGame extends Game{

    private String player1;
    private String player2;

    public SeededGame(String player1, String player2) {
        super();
        this.player1 = player1;
        this.player2 = player2;
    }

    @Override
    public String getPlayer1() {
        return player1;
    }

    @Override
    public String getPlayer2() {
        return player2;
    }

    @Override
    public List<String> getAllPlayers() {
        //return new ArrayList<String>(Arrays.asList(player1, player2));
        return List.of(player1, player2);
    }
    
    @Override
    public List<String> getRemaningPlayers() {
        if(this.getWinner() != null) { 
            return new ArrayList<>(Arrays.asList(this.getWinner()));
        }

        return List.of(player1, player2);
    }

    @Override
    public List<Game> getAllGames() {
        return List.of(this);
    }
}

