package logistics;

import logistics.material.BulletBelts;
import logistics.material.MetGallonsKerosene;
import logistics.material.RocketPods;
import logistics.quantities.NeedCollector;
import logistics.storage.FloatStorage;
import logistics.storage.IntStorage;

public class Helicopter extends Vehicle {

    public IntStorage bullets;
    public IntStorage rockets;
    public FloatStorage tank;

    public Helicopter(String name, float kerosene, int bulletBelts, int rocketPods) {
        super(name);
        this.tank = new FloatStorage(kerosene, MetGallonsKerosene.INSTANCE, 500);
        bullets = new IntStorage(bulletBelts, BulletBelts.INSTANCE, 2);
        rockets = new IntStorage(rocketPods, RocketPods.INSTANCE, 2);

    }

    @Override
    public void reportNeeds(NeedCollector collector) {
        oil.reportNeed(collector);
        grease.reportNeed(collector);
        tank.reportNeed(collector);
        bullets.reportNeed(collector);
        rockets.reportNeed(collector);
    }

    @Override
    public void fillUpAll() {
        oil.fillUp();
        grease.fillUp();
        tank.fillUp();
        bullets.fillUp();
        rockets.fillUp();
    }

    @Override
    public void consumeAll(int intensityRate) {
        tank.consume(intensityRate * 200);
        bullets.consume(intensityRate);
        rockets.consume(intensityRate);
        oil.consume(1);
        grease.consume(1);
    }
}
