package logistics;

import logistics.material.Grease;
import logistics.material.Oil;
import logistics.quantities.NeedCollector;
import logistics.storage.IntStorage;

public abstract class Vehicle {
    public String name;
    public IntStorage oil;
    public IntStorage grease;

    public Vehicle(String name) {
        this.name = name;
        this.oil = new IntStorage(0, Oil.INSTANCE, 3);
        this.grease = new IntStorage(0, Grease.INSTANCE, 3);
    }

    public abstract void reportNeeds(NeedCollector collector);

    public abstract void fillUpAll();

    public abstract void consumeAll(int intensity);




    public void consumeAll(){
        oil.consume(1);
        grease.consume(1);
    }

    public void fillUpAllSuper(){
        oil.fillUp();
        grease.fillUp();
    }

    public void reportNeedsSuper(NeedCollector collector){
        oil.reportNeed(collector);
        grease.reportNeed(collector);
    }
    
}
