package quantities.generic;

import static quantities.generic.LengthUnit.METER;
import static quantities.generic.TimeUnit.SECOND;
import static quantities.generic.VelocityUnit.METER_PER_SECOND;

public class Length extends Quantity<Length>{

    public Length(double value, Unit<Length> unit) {
        super(value, unit);
    }

    public Velocity div(Time t) {
        return METER_PER_SECOND.quantity(this.value(METER) / t.value(SECOND));
    }

    public Time div(Velocity v) {
        return SECOND.quantity(this.value(METER) / v.value(METER_PER_SECOND));
    }


}
