package doc;
import java.util.List;

public class CountWordsVisitor implements Visitor<Integer>{

    public Integer visit(Paragraph e){
        String text = e.getText();
        int wordCount = 0;
        boolean open = false;
        for (char i : text.toCharArray()){
            if(!open && Character.isAlphabetic(i)){
                open = true;
            }
            else if(open && !Character.isAlphabetic(i)){
                open = false;
                wordCount++;
            }
        }
        if (open){
            open = false;
            wordCount++;
        }
        return wordCount;
    }

    public Integer visit(Image e){
        return 0;
    }

    public Integer visit(Section e){
        List<TextComponent> contents = e.getContents();
        int wordCount = 0;
        for (TextComponent c: contents){
            wordCount += c.accept(this);
        }
        return wordCount;
    }
}