package doc;
import java.util.List;

public class Section implements TextComponent{

    private String header;
    private List<TextComponent> contents;

    public Section(String header, List<TextComponent> contents){
        this.header = header;
        this.contents = contents;
    }

    public String getHeader(){
        return header;
    }

    public List<TextComponent> getContents(){
        return contents;
    }

    public int countWords(){
        int wordCount = 0;
        for(TextComponent i : contents){
            wordCount = wordCount + i.countWords();
        }
        return wordCount;
    }
    
    

    public <T> T accept(Visitor<T> v){
        return v.visit(this);
    }
}
